package eu.ztsh.wymiana.util;

import eu.ztsh.wymiana.data.entity.CurrencyEntity;
import eu.ztsh.wymiana.data.entity.UserEntity;
import eu.ztsh.wymiana.model.User;
import eu.ztsh.wymiana.model.UserCreateRequestConfiguredWrapper;

import java.util.List;

public class UserMapper {

    public static User entityToPojo(UserEntity entity) {
        return new User(entity.getName(), entity.getSurname(), entity.getPesel(),
            CurrencyMapper.entitiesToPojoMap(entity.getCurrencies()));
    }

    public static UserEntity pojoToEntity(User pojo) {
        return new UserEntity(pojo.pesel(), pojo.name(), pojo.surname(),
            CurrencyMapper.pojoMapToEntities(pojo.currencies(), pojo.pesel()));
    }

    public static UserEntity requestToEntity(UserCreateRequestConfiguredWrapper request) {
        return new UserEntity(request.pesel(), request.name(), request.surname(),
            List.of(new CurrencyEntity(request.pesel(), request.initialSymbol(), request.initial())));
    }

    private UserMapper() {
    }

}
